import { BaseProvider } from './base-provider';
export interface ClassProvider {
    provide: string;
    useClass: typeof BaseProvider;
}
export declare type ValueProvider = {
    provide: string;
    useValue: any;
};
export declare type FactoryProvider = {
    provide: string;
    useFactory: any;
};
export declare type NormalProvider = ValueProvider | FactoryProvider | ClassProvider;
export declare type Provider = ValueProvider | FactoryProvider | ClassProvider | (new (...args: any[]) => any);
export interface ContainerProps {
    providers: Provider[];
}
export declare class Container {
    private providers;
    private instanceMap;
    depsMap: Map<string, any>;
    constructor({ providers }: ContainerProps);
    getInstance(name: any): any;
    registerProviders(providers: Provider[]): void;
    getProviders(): Map<string, NormalProvider>;
    getInstanceMap(): Map<string, any>;
}
