"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.createPool = void 0;
var container_1 = require("./container");
function createPool(props) {
    var container = new container_1.Container(__assign({}, props));
    function Inject(name) {
        return function (target, propName) {
            Object.defineProperty(target, propName, {
                get: function () {
                    if (!this.value) {
                        this.value = inject(name);
                    }
                    return this.value;
                },
            });
        };
    }
    function inject(name) {
        if (!container) {
            throw new Error('root IOC container does not exists. ');
        }
        var instance = container === null || container === void 0 ? void 0 : container.getInstance(name);
        return instance;
    }
    return { container: container, inject: inject, Inject: Inject };
}
exports.createPool = createPool;
